package edu.cmu.paid.learning.logger;
import java.util.Vector;
import java.util.Hashtable;
import edu.cmu.paid.database.datamodel.*;

/***/
public class UpdateTuple extends edu.cmu.paid.learning.logger.Tuple {
  // setting constants to arbitrary values.
  final static int HIGHCOST = 1000;
  final static int LOWCOST  = 100;
  final static int LOWSERVERLOAD = 100;
  final static int HIGHSERVERLOAD = 1000;
  final static int LOWNETLOAD = 100;
  final static int HIGHNETLOAD = 1000;
  private Vector v;

  public UpdateTuple() { super(); }

  public UpdateTuple(AccessLogData l, boolean withResponse) {
    super(l, withResponse);
    v = new Vector();
    v.addElement(""+getCost(l));
    v.addElement(""+getNetworkLoad(l));
    v.addElement(""+getServerLoad(l));
    v.addElement(""+l.getTimeStamp());
    
    if (withResponse)
      v.addElement(""+l.getUpdateSuggestion());
  }       

  public Vector getVector() {
    return v;
  }

   public Hashtable getMetaData() {
    Hashtable meta = new Hashtable();

    // Dependant variables
    Vector dvn = new Vector();
    dvn.addElement("Defer");
    dvn.addElement("Update");
    meta.put("Dependent", dvn);

    // Independant Variable Names
    Vector ivn = new Vector();
    ivn.addElement("AccessTimeStamp");
    ivn.addElement("DealerConnectionCost");
    ivn.addElement("NetworkLoad");
    ivn.addElement("ServerLoad");
    meta.put("Independent", ivn);
    
    // AccessTimeStamp
    Vector ats = new Vector();
    ats.addElement("continous");
    meta.put("AccessTimeStamp", ats);
    
    // make vector for high, low, med
    Vector hml = new Vector();
    hml.addElement(HIGH);
    hml.addElement(LOW);
    hml.addElement(MED);
    
    // DealerConnectionCost, NetworkLoad, ServerLoad
    meta.put("DealerConnectionCost", hml.clone());
    meta.put("NetworkLoad", hml.clone());
    meta.put("ServerLoad", hml.clone());

    return meta;
  }
 

  private String getCost(AccessLogData l) {
    return classify(l.getDealerConnectionCost().intValue(), 
		    LOWCOST, HIGHCOST);
  }
  
  private String getServerLoad(AccessLogData l) {
    return classify(l.getServerLoad().intValue(), 
		    LOWSERVERLOAD, HIGHSERVERLOAD);
  }

  private String getNetworkLoad(AccessLogData l) {
    return classify(l.getNetworkLoad().intValue(),
		    LOWNETLOAD, HIGHNETLOAD);
  }



}

/***/
class UpdateTupleTest{
  public static void main(String[] argv) {
    UpdateTuple UT = new UpdateTuple();
    System.out.println(UT.getMetaData().toString());
  }
}
